libqalculate-5.11.0: DynamicVariable Class Reference

libqalculate-5.11.0

Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
DynamicVariable Class Referenceabstract

Abstract base class for variables with a value which is recalculated when the precision has changed. More...

`#include <Variable.h>`

Inheritance diagram for DynamicVariable:

## Public Member Functions
| DynamicVariable (std::string cat_, std::string name_, std::string title_="", bool is_local=false, bool is_builtin=true, bool is_active=true)
| DynamicVariable (const DynamicVariable *variable)
ExpressionItem * | copy () const =0
void | set (const ExpressionItem *item)
const MathStructure & | get ()
void | set (const MathStructure &o)
void | set (std::string expression_)
int | calculatedPrecision () const
virtual bool | representsPositive (bool=false)
virtual bool | representsNegative (bool=false)
virtual bool | representsNonNegative (bool=false)
virtual bool | representsNonPositive (bool=false)
virtual bool | representsInteger (bool=false)
virtual bool | representsNonInteger (bool=false)
virtual bool | representsNumber (bool=false)
virtual bool | representsRational (bool=false)
virtual bool | representsReal (bool=false)
virtual bool | representsComplex (bool=false)
virtual bool | representsNonZero (bool=false)
virtual bool | representsEven (bool=false)
virtual bool | representsOdd (bool=false)
virtual bool | representsUndefined (bool=false, bool=false, bool=false)
virtual bool | representsBoolean ()
virtual bool | representsNonMatrix ()
virtual bool | representsScalar ()
Public Member Functions inherited from KnownVariable
| KnownVariable (std::string cat_, std::string name_, const MathStructure &o, std::string title_="", bool is_local=true, bool is_builtin=false, bool is_active=true)
| KnownVariable (std::string cat_, std::string name_, std::string expression_, std::string title_="", bool is_local=true, bool is_builtin=false, bool is_active=true)
| KnownVariable ()
| KnownVariable (const KnownVariable *variable)
bool | isKnown () const
virtual bool | isExpression () const
virtual std::string | expression () const
virtual std::string | uncertainty (bool *is_relative=NULL) const
virtual std::string | unit () const
int | subtype () const
virtual void | setUncertainty (std::string standard_uncertainty, bool is_relative=false)
virtual void | setUnit (std::string unit_expression)
virtual bool | representsFraction (bool=false)
virtual bool | representsNonComplex (bool=false)
virtual int | id () const
Public Member Functions inherited from Variable
| Variable (std::string cat_, std::string name_, std::string title_="", bool is_local=true, bool is_builtin=false, bool is_active=true)
| Variable (const Variable *variable)
virtual int | type () const
Public Member Functions inherited from ExpressionItem
| ExpressionItem (std::string cat_, std::string name_, std::string title_="", std::string descr_="", bool is_local=true, bool is_builtin=false, bool is_active=true)
virtual bool | destroy ()
bool | isRegistered () const
void | setRegistered (bool is_registered)
| For internal use.
virtual const std::string & | name (bool use_unicode=false, bool(*can_display_unicode_string_function)(const char *, void *)=NULL, void *can_display_unicode_string_arg=NULL) const
virtual const std::string & | referenceName () const
virtual const ExpressionName & | preferredName (bool abbreviation=false, bool use_unicode=false, bool plural=false, bool reference=false, bool(*can_display_unicode_string_function)(const char *, void *)=NULL, void *can_display_unicode_string_arg=NULL) const
virtual const ExpressionName & | preferredInputName (bool abbreviation=false, bool use_unicode=false, bool plural=false, bool reference=false, bool(*can_display_unicode_string_function)(const char *, void *)=NULL, void *can_display_unicode_string_arg=NULL) const
virtual const ExpressionName & | preferredDisplayName (bool abbreviation=false, bool use_unicode=false, bool plural=false, bool reference=false, bool(*can_display_unicode_string_function)(const char *, void *)=NULL, void *can_display_unicode_string_arg=NULL) const
virtual const ExpressionName & | getName (size_t index) const
virtual void | setName (const ExpressionName &ename, size_t index=1, bool force=true)
virtual void | setName (std::string sname, size_t index, bool force=true)
virtual void | addName (const ExpressionName &ename, size_t index=0, bool force=true)
virtual void | addName (std::string sname, size_t index=0, bool force=true)
virtual size_t | countNames () const
virtual void | clearNames ()
virtual void | clearNonReferenceNames ()
virtual void | removeName (size_t index)
virtual size_t | hasName (const std::string &sname, bool case_sensitive=true) const
virtual size_t | hasNameCaseSensitive (const std::string &sname) const
virtual const ExpressionName & | findName (int abbreviation=-1, int use_unicode=-1, int plural=-1, bool(*can_display_unicode_string_function)(const char *, void *)=NULL, void *can_display_unicode_string_arg=NULL) const
virtual const std::string & | title (bool return_name_if_no_title=true, bool use_unicode=false, bool(*can_display_unicode_string_function)(const char *, void *)=NULL, void *can_display_unicode_string_arg=NULL) const
virtual void | setTitle (std::string title_)
virtual const std::string & | description () const
virtual void | setDescription (std::string descr_)
virtual const std::string & | category () const
virtual void | setCategory (std::string cat_)
virtual bool | hasChanged () const
virtual void | setChanged (bool has_changed)
virtual bool | isLocal () const
virtual bool | setLocal (bool is_local=true, int will_be_active=-1)
virtual bool | isBuiltin () const
virtual bool | isApproximate () const
virtual void | setApproximate (bool is_approx=true)
virtual int | precision () const
virtual void | setPrecision (int prec)
virtual bool | isActive () const
virtual void | setActive (bool is_active)
virtual bool | isHidden () const
virtual void | setHidden (bool is_hidden)
virtual int | refcount () const
virtual void | ref ()
virtual void | unref ()
virtual void | ref (ExpressionItem *o)
virtual void | unref (ExpressionItem *o)
virtual ExpressionItem * | getReferencer (size_t index=1) const
virtual bool | changeReference (ExpressionItem *o_from, ExpressionItem *o_to)

## Protected Member Functions
virtual void | calculate (MathStructure &m) const =0

## Protected Attributes
bool | always_recalculate
Protected Attributes inherited from KnownVariable
MathStructure * | mstruct
MathStructure * | mstruct_alt
bool | b_expression
int | calculated_precision
std::string | sexpression
std::string | suncertainty
std::string | sunit
bool | b_relative_uncertainty
Protected Attributes inherited from ExpressionItem
std::string | scat
std::string | stitle
std::string | sdescr
bool | b_local
bool | b_changed
bool | b_builtin
bool | b_approx
bool | b_active
bool | b_registered
bool | b_hidden
bool | b_destroyed
int | i_ref
int | i_precision
std::vector< ExpressionItem * > | v_refs
std::vector< ExpressionName > | names

## Detailed Description

Abstract base class for variables with a value which is recalculated when the precision has changed.

## Member Function Documentation

## ◆ calculatedPrecision()

int DynamicVariable::calculatedPrecision | ( |  | ) | const

Returns the precision of the calculated value.

Returns
  Precision of the calculated value or zero if the value has not yet been calculated.

## ◆ copy()

ExpressionItem * DynamicVariable::copy | ( |  | ) | const
| pure virtual

Reimplemented from KnownVariable.

## ◆ get()

const MathStructure & DynamicVariable::get | ( |  | ) |
| virtual

Returns the value of the variable. If no value is set or parsed and an expression is set, the expression is parsed and resulting value returned.

Returns
  The value of the variable..

Reimplemented from KnownVariable.

## ◆ representsBoolean()

virtual bool DynamicVariable::representsBoolean | ( |  | ) |
| inlinevirtual

Reimplemented from KnownVariable.

## ◆ representsComplex()

virtual bool DynamicVariable::representsComplex | ( | bool | = false | ) |
| inlinevirtual

Reimplemented from KnownVariable.

## ◆ representsEven()

virtual bool DynamicVariable::representsEven | ( | bool | = false | ) |
| inlinevirtual

Reimplemented from KnownVariable.

## ◆ representsInteger()

virtual bool DynamicVariable::representsInteger | ( | bool | = false | ) |
| inlinevirtual

Reimplemented from KnownVariable.

## ◆ representsNegative()

virtual bool DynamicVariable::representsNegative | ( | bool | = false | ) |
| inlinevirtual

Reimplemented from KnownVariable.

## ◆ representsNonInteger()

virtual bool DynamicVariable::representsNonInteger | ( | bool | = false | ) |
| inlinevirtual

Reimplemented from KnownVariable.

## ◆ representsNonMatrix()

virtual bool DynamicVariable::representsNonMatrix | ( |  | ) |
| inlinevirtual

Reimplemented from KnownVariable.

## ◆ representsNonNegative()

virtual bool DynamicVariable::representsNonNegative | ( | bool | = false | ) |
| inlinevirtual

Reimplemented from KnownVariable.

## ◆ representsNonPositive()

virtual bool DynamicVariable::representsNonPositive | ( | bool | = false | ) |
| inlinevirtual

Reimplemented from KnownVariable.

## ◆ representsNonZero()

virtual bool DynamicVariable::representsNonZero | ( | bool | = false | ) |
| inlinevirtual

Reimplemented from KnownVariable.

## ◆ representsNumber()

virtual bool DynamicVariable::representsNumber | ( | bool | = false | ) |
| inlinevirtual

Reimplemented from KnownVariable.

## ◆ representsOdd()

virtual bool DynamicVariable::representsOdd | ( | bool | = false | ) |
| inlinevirtual

Reimplemented from KnownVariable.

## ◆ representsPositive()

virtual bool DynamicVariable::representsPositive | ( | bool | = false | ) |
| inlinevirtual

Returns if the variable represents a positive value.

Reimplemented from KnownVariable.

Reimplemented in NowVariable, TodayVariable, TomorrowVariable, and YesterdayVariable.

## ◆ representsRational()

virtual bool DynamicVariable::representsRational | ( | bool | = false | ) |
| inlinevirtual

Reimplemented from KnownVariable.

## ◆ representsReal()

virtual bool DynamicVariable::representsReal | ( | bool | = false | ) |
| inlinevirtual

Reimplemented from KnownVariable.

## ◆ representsScalar()

virtual bool DynamicVariable::representsScalar | ( |  | ) |
| inlinevirtual

Reimplemented from KnownVariable.

## ◆ representsUndefined()

virtual bool DynamicVariable::representsUndefined | ( | bool | = false,
|  | bool | = false,
|  | bool | = false )
| inlinevirtual

Reimplemented from KnownVariable.

## ◆ set() [1/3]

void DynamicVariable::set | ( | const ExpressionItem * | item | ) |
| virtual

Reimplemented from KnownVariable.

## ◆ set() [2/3]

void DynamicVariable::set | ( | const MathStructure & | o | ) |
| virtual

Sets the value of the variable. If expression is set, it is cleared.

Parameters

  o | Value.

Reimplemented from KnownVariable.

## ◆ set() [3/3]

void DynamicVariable::set | ( | std::string | expression_ | ) |
| virtual

Sets the text string expression of the variable. The value is cleared.

Parameters

  expression_ | Expression.

Reimplemented from KnownVariable.

The documentation for this class was generated from the following file:

- /build/libqalculate/src/libqalculate/libqalculate/Variable.h